# 起步

## 前置知识

在这里我们假设你已经对 [HTML][html]，[CSS][css] 和 [JavaScript][js] 的前置知识都比较熟悉了，同时，你需要了解 [AMD 模块][amd]，Node 运行时引擎和 Ralltiir 单页异步框架核心。不过即使你之前都没有了解过也可以接着跟着本节教程试试看。

Ralltiir Application 的后续规划中可能会使用 ES6 或 TypeScript，如果你想了解一下 ES6 的新特性，我们推荐你阅读 [ECMAScript 2015 Language Specification][es6]，你也可以使用 [Babel REPL][babel] 在线预览一下 ES6 的代码被编译后的效果。如果你想对 TypeScript 的静态类型检查和基于类的面向对象编程有了解，我们推荐你阅读 [TypeScript Tutorials][ts]。

## 如何编写代码

你可以选择在本地的代码编辑器软件里开始编写代码，需要的是在本地配置一下开发运行环境。虽然在本地搭建环境要费一些功夫，但好处是你可以任意选择你惯用的编辑器来完成开发。

在这里我们推荐你使用 Visual Studio Code 或者 WebStorm。

## 寻求帮助

如果你遇到了任何困难，可以在参考手册的[常见问题][common-problem]里寻求帮助。如果通过上述方式还是解决不了你的问题，你也可以给我们提一个 issue。

[html]: https://developer.mozilla.org/en-US/docs/Web/HTML
[css]: https://developer.mozilla.org/en-US/docs/Web/CSS
[js]: https://developer.mozilla.org/en-US/docs/Web/JavaScript
[amd]: https://requirejs.org/docs/whyamd.html
[es6]: https://www.ecma-international.org/ecma-262/6.0/
[babel]: https://babeljs.io/repl/#?babili=false&evaluate=true&lineWrap=false&presets=es2015%2Creact&experimental=false&loose=false&spec=false&code=const%20element%20%3D%20%3Ch1%3EHello%2C%20world!%3C%2Fh1%3E%3B%0Aconst%20container%20%3D%20document.getElementById('root')%3B%0AReactDOM.render(element%2C%20container)%3B%0A
[ts]: https://www.typescriptlang.org/docs/handbook/typescript-in-5-minutes.html
[common-problem]: https://ralltiir.github.io/ralltiir-application/reference/common-problem.html
